<?php
declare(strict_types=1);

namespace Intergo\LaravelAuthMiddleware\Http\Middleware;
use Intergo\LaravelAuthMiddleware\Traits\ResponseTrait;
use Illuminate\Http\Request;
use Closure;

class AuthenticateAPI extends AbstractAuthMiddleware
{
    use ResponseTrait;
    /**
     * Handle an incoming request.
     *
     * @param Request $request
     * @param Closure $next
     * @param string $params
     * @return mixed
     */
    public function handle(Request $request, Closure $next, string $params = ''): mixed
    {
        $result = parent::handle($request, $next);
        if (!$result->isSuccessful()) {
            return $this->failed('Invalid API Key or Token', [], $result->getStatusCode());
        }
        return $next($this->request);
    }

    /**
     * @return string|null
     */
    protected function getToken()
    {
        return $this->request->bearerToken() ?? $this->request->api_key;
    }
}

