<?php
declare(strict_types=1);

namespace Intergo\LaravelAuthMiddleware\Http\Middleware;
use Illuminate\Support\Facades\Session;
use Intergo\LaravelAuthMiddleware\Services\Microservices\AuthService;
use Intergo\LaravelAuthMiddleware\Traits\ResponseTrait;
use Illuminate\Http\Request;
use Closure;

class AuthenticateWeb extends AbstractAuthMiddleware
{
    use ResponseTrait;
    /**
     * Handle an incoming request.
     *
     * @param Request $request
     * @param Closure $next
     * @param string $params
     * @return mixed
     */
    public function handle(Request $request, Closure $next, string $params = ''): mixed
    {
        $result = parent::handle($request, $next);
        if (!$result->isSuccessful()) {
            return redirect(route('login'));
        }
        return $next($this->request);
    }

    /**
     * @return string|null
     */
    protected function getToken()
    {
        return Session::get(AuthService::SESSION_JWT_TOKEN) ?? $this->request->bearerToken() ?? $this->request->api_key;
    }
}

